/* @clake/react-bootstrap4-window v0.3.4 | by Clake
 * Copyright (c) 2020 Clake,
 * 2020-03-27T00:15:45+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal["default"].signature : function (a) {
  return a;
};

var defIndex = 100;

var WindowGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(WindowGroup, _React$Component);

  function WindowGroup(props) {
    var _this;

    _classCallCheck(this, WindowGroup);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WindowGroup).call(this, props));
    _this.state = {
      showWindows: []
    }; //ref window components

    _this.windows = {}; //opened window list

    _this.opens = []; //windows

    _this.windowList = {}; //current active window

    _this.currentActive = null;

    _react["default"].Children.map(_this.props.children, function (item) {
      _this.windowList[item.props.name] = item;
    });

    return _this;
  }

  _createClass(WindowGroup, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
    /**
     * open window
     * @param name string
     * @param params object
     */

  }, {
    key: "open",
    value: function open(name, params) {
      var _this2 = this;

      if (this.currentActive) {
        this.windows[this.currentActive].setActive(false);
        this.currentActive = name;
      }

      if (this.opens.indexOf(name) !== -1) {
        this.changeWindowIndex(name);
        this.windows[name].show({
          params: params
        });
        return;
      }

      if (this.windowList[name]) {
        if (this.state.showWindows.indexOf(name) !== -1) {
          this.show(name, params);
          return;
        }

        var showWindows = this.state.showWindows;
        showWindows.push(name);
        this.setState({
          showWindows: showWindows
        }, function () {
          _this2.show(name, params);
        });
      }
    }
  }, {
    key: "show",
    value: function show(name, params) {
      var option = {
        x: this.opens.length * 20 + 10,
        y: this.opens.length * 20 + 10,
        params: params
      };
      this.windows[name].show(option);
      this.opens.push(name);
      this.changeWindowIndex(name);
    }
  }, {
    key: "changeWindowIndex",
    value: function changeWindowIndex(name) {
      var _this3 = this;

      if (this.currentActive) {
        this.windows[this.currentActive].setActive(false);
        this.currentActive = name;
      }

      this.opens.splice(this.opens.indexOf(name), 1);
      this.opens.push(name);
      this.opens.forEach(function (key, index) {
        _this3.windows[key].setActive(key === name);

        _this3.windows[key].setIndex(defIndex + index);
      });
    }
  }, {
    key: "removeWindowOpens",
    value: function removeWindowOpens(name) {
      var _this4 = this;

      this.opens.splice(this.opens.indexOf(name), 1);
      this.opens.forEach(function (key, index) {
        _this4.windows[key].setIndex(defIndex + index);
      }); // let showWindows = this.state.showWindows.slice(0);
      // showWindows.splice(showWindows.indexOf(name),1);
      // this.setState({
      //     showWindows: showWindows,
      // });
    }
  }, {
    key: "close",
    value: function close(name) {
      if (this.windows[name]) {
        this.windows[name].close();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      return this.state.showWindows.map(function (name) {
        var item = _this5.windowList[name];
        item.props.parent = _this5;

        item.props.ref = function (c) {
          return _this5.windows[name] = c;
        };

        return _react["default"].cloneElement(item, item.props);
      });
    } // render() {
    //     return React.Children.map(this.props.children,(item)=>{
    //         item.props.parent = this;
    //         item.props.ref = c=>this.windows[item.props.name]=c;
    //         return React.cloneElement(item,item.props,item.props.children);
    //     })
    // }

  }, {
    key: "__reactstandin__regenerateByEval",
    // @ts-ignore
    value: function __reactstandin__regenerateByEval(key, code) {
      // @ts-ignore
      this[key] = eval(code);
    }
  }]);

  return WindowGroup;
}(_react["default"].Component);

WindowGroup.propTypes = {};
WindowGroup.defaultProps = {};
var _default = WindowGroup;
var _default2 = _default;
exports["default"] = _default2;
;

(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(defIndex, "defIndex", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/WindowGroup.js");
  reactHotLoader.register(WindowGroup, "WindowGroup", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/WindowGroup.js");
  reactHotLoader.register(_default, "default", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/WindowGroup.js");
})();

;

(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
//# sourceMappingURL=WindowGroup.js.map
